************************************************************************
      subroutine sfsccc(l2,l1,ew2,ew1,am2,am1,cpl,ce2,ce1,
     &                 ps2,ps1,lt,av)
      implicit real*8(a-h,o-z)
      parameter (zero = 0.0d0, one = 1.0d0)
*   * dummy array size.
      parameter (ltsize = 20, lasize = 1024)
      integer    l1, l2
      dimension  ew1(1), ew2(1)
*     real*8     am1, am2
      complex*16 cpl(2)
      complex*16 ce1(2,l1), ce2(2,l2)
      dimension  ps1(4,3), ps2(4,3)
*     dimension  ps1(4,l1/2+1), ps2(4,l2/2+1)
      complex*16 av(0:lasize)
*     complex*16 av(0:l2*l1-1)
      integer    lt(0:ltsize)
*
*    Calculate fermion-fermion-scalar vertex.
*
*           ! 3                 _      _
*           !                1  u  or  v
*      -->--+-->---          2  u  or  v
*        2     1             3  scalar boson
*
*     L1, L2   : input  : If external then 2 else 4, for fermion
*     EW1, EW2 : input  : If >=0 then particle else anti-particle
*     AM1, AM2 : input  : masses of the fermions
*     CPL      : input  : coupling constants (L, R)
*     CE1, CE2 : input  : phase factor, calculated by SMINTF or SMEXTF
*     PS1, PS2 : input  : decomposed momenta (L21, L22 , L1) or
*                         (L21, L22) calculated by SMINTF or SMEXTF
*     AV       : output : table of amplitudes
*     LT       : output : table of sizes in AV
*
      complex*16 avt(2,2,2,2), cpn
      complex*16 ce1r(2,4)
      complex*16 ce2r(2,4)
      dimension  p0(4), cpr(2)
      data p0/0.0d0,0.0d0,0.0d0,0.0d0/, am0/0.0d0/
*-----------------------------------------------------------------------
      if(cpl(1).ne.zero) then
        cpn = cpl(1)
        cpr(1) = one
        cpr(2) = cpl(2)/cpl(1)
      else if(cpl(2).ne.zero) then
        cpn = cpl(2)
        cpr(2) = one
        cpr(1) = cpl(1)/cpl(2)
      else
cc      write(6,*) '*** sfsccc:coupling constant for ffs vertex is 0.'
cc      write(6,*) 'l2=',l2,' l1=',l1,' ew2=',ew2,' ew1=',ew1
cc      write(6,*) 'am2=',am2,' am1=',am1,' cpl=',cpl
cc      for facom
cc      call sdfdmp(1, 0)
cc      stop
        cpn = zero
        cpr(1) = one
        cpr(2) = one
      endif
      if(ew1(1).ge.zero) then
        k1 = 3
      else
        k1 = 1
      endif
      if(ew2(1).ge.zero) then
        k2 = 3
      else
        k2 = 1
      endif
      lt(0) = 3
      lt(1) = l2
      lt(2) = l1
      lt(3) = 1
      ce1r(1,2) = conjg(ce1(1,1))
      ce1r(2,2) = conjg(ce1(2,1))
      ce2r(1,1) = conjg(ce2(1,2))
      ce2r(2,1) = conjg(ce2(2,2))
      call ffsccc(k1,k2,am1,am2,cpr(1),cpr(2),ce1r(1,2),ce2r(1,1),
     &         ps1(1,1),ps1(1,2),ps2(1,1),ps2(1,2), avt(1,1,1,1))
      if(l1.eq.4) then
        ce1r(1,4) = conjg(ce1(1,3))
        ce1r(2,4) = conjg(ce1(2,3))
          call ffsccc( 3,k2,am0,am2,cpr(1),cpr(2),ce1r(1,4),ce2r(1,1),
     &             ps1(1,3),p0,      ps2(1,1),ps2(1,2), avt(1,1,2,1))
      endif
      if(l2.eq.4) then
        ce2r(1,3) = conjg(ce2(1,4))
        ce2r(2,3) = conjg(ce2(2,4))
          call ffsccc(k1, 3,am1,am0,cpr(1),cpr(2),ce1r(1,2),ce2r(1,3),
     &             ps1(1,1),ps1(1,2),ps2(1,3),p0,       avt(1,1,1,2))
  300   continue
      endif
      if(l1.eq.4 .and. l2.eq.4) then
          call ffsccc( 3, 3,am0,am0,cpr(1),cpr(2),ce1r(1,4),ce2r(1,3),
     &             ps1(1,3),p0,      ps2(1,3),p0,       avt(1,1,2,2))
  400   continue
      endif
      ia = 0
      do 500 ip1 = 1, l1/2
      do 500 il1 = 1, 2
      do 500 ip2 = 1, l2/2
      do 500 il2 = 1, 2
        av(ia) = cpn*avt(il1, il2, ip1, ip2)
        ia = ia + 1
  500 continue
*     call ctime('sfsccc ')
      return
      end
