************************************************************************
      subroutine sfvncn(l2,l1,lv,ew2,ew1,am2,am1,cpl,ce2,ce1,
     &                 ps2,ps1,ep,lt,av)
      implicit real*8(a-h,o-z)
      parameter (zero = 0.0d0, one = 1.0d0)
*   * dummy array size.
      parameter (ltsize = 20, lasize = 1024)
      integer    l1, l2, lv
      dimension  ew1(1), ew2(1)
*     real*8     am1, am2
      complex*16 cpl(2)
      complex*16 ce1(2,l1), ce2(2,l2)
      dimension  ps1(4,3), ps2(4,3)
*     dimension  ps1(4,l1/2+1), ps2(4,l2/2+1)
      dimension  ep(4,lv)
      complex*16 av(0:lasize)
*     complex*16 av(0:lv*l2*l1-1)
      integer    lt(0:ltsize)
*
*    Calculate fermion-fermion-vector vertex.
*
*           ! 3                 _      _
*           !                1  u  or  v
*      -->--+-->---          2  u  or  v
*        2     1             3  vector boson
*
*     L1, L2   : input  : If external then 2 else 4, for fermion
*     LV       : input  : number of polarization vectors (2, 3 OR 4)
*     EW1, EW2 : input  : If >=0 then particle else anti-particle
*     AM1, AM2 : input  : masses of the fermions
*     CPL      : input  : coupling constants (L, R)
*     CE1, CE2 : input  : phase factor, calculated by SMINTF or SMEXTF
*     PS1, PS2 : input  : decomposed momenta (L21, L22 , L1) or
*                         (L21, L22) calculated by SMINTF or SMEXTF
*     EP       : input  : set of polarization vectors
*     AV       : output : table of amplitudes
*     LT       : output : table of sizes in AV
*
      complex*16 avt(4,2,2,2,2), cpn
      dimension  p0(4), cpr(2)
      data p0/0.0d0,0.0d0,0.0d0,0.0d0/, am0/0.0d0/
*-----------------------------------------------------------------------
      if(cpl(1).ne.zero) then
        cpn = cpl(1)
        cpr(1) = one
        cpr(2) = cpl(2)/cpl(1)
      else if(cpl(2).ne.zero) then
        cpn = cpl(2)
        cpr(2) = one
        cpr(1) = cpl(1)/cpl(2)
      else
cc      write(6,*) '*** sfvncn:coupling constant for ffv vertex is 0.'
cc      write(6,*) 'l2=',l2,' l1=',l1,' lv=',lv,' ew2=',ew2,' ew1=',ew1
cc      write(6,*) 'am2=',am2,' am1=',am1,' cpl=',cpl
cc      for facom
cc      call sdfdmp(1, 0)
cc      stop
        cpn = zero
        cpr(1) = one
        cpr(2) = one
      endif
      if(ew1(1).ge.zero) then
        k1 = 3
      else
        k1 = 1
      endif
      if(ew2(1).ge.zero) then
        k2 = 3
      else
        k2 = 1
      endif
      lt(0) = 3
      lt(1) = l2
      lt(2) = l1
      lt(3) = lv
      do 100 lp = 1, lv
      call ffvncn(lp,k1,k2,am1,am2,cpr(1),cpr(2), ce1(1,2),ce2(1,1),
     &         ps1(1,1),ps1(1,2),ps2(1,1),ps2(1,2),ep(1,lp),
     &         avt(1,1,1,1,1))
  100 continue
      if(l1.eq.4) then
        do 200 lp = 1, lv
          call ffvncn(lp,3,k2,am0,am2,cpr(1),cpr(2), ce1(1,4),ce2(1,1),
     &             ps1(1,3),p0,ps2(1,1),ps2(1,2),ep(1,lp),
     &             avt(1,1,1,2,1))
  200   continue
      endif
      if(l2.eq.4) then
        do 300 lp = 1, lv
          call ffvncn(lp,k1,3,am1,am0,cpr(1),cpr(2), ce1(1,2),ce2(1,3),
     &             ps1(1,1),ps1(1,2),ps2(1,3),p0,ep(1,lp),
     &             avt(1,1,1,1,2))
  300   continue
      endif
      if(l1.eq.4 .and. l2.eq.4) then
        do 400 lp = 1, lv
          call ffvncn(lp,3,3,am0,am0,cpr(1),cpr(2), ce1(1,4),ce2(1,3),
     &             ps1(1,3),p0,ps2(1,3),p0,ep(1,lp),
     &             avt(1,1,1,2,2))
  400   continue
      endif
      ia = 0
      do 500 il  = 1, lv
      do 500 ip1 = 1, l1/2
      do 500 il1 = 1, 2
      do 500 ip2 = 1, l2/2
      do 500 il2 = 1, 2
        av(ia) = cpn*avt(il, il1, il2, ip1, ip2)
        ia = ia + 1
  500 continue
*     call ctime('sfvncn ')
      return
      end
