      PROGRAM grappa
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C  PSKINI information
      common/PSKfail/ ifail_pskini,nfail_pskini

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

      character*80 lhafile

Ch      parameter ( lhcom = 100000 )
Ch      real*4 h
Ch      common /pawc/h(lhcom)
Ch      character*72 flhist
      real*4 weight

C  Output hbook file; "*" for no output.
C      flhist= '*'
Ch      flhist= 'hist.hbook'

C  Number of events to generate.
      nevent= 1000

C  Logical unit number for the output event file; 0 for no output.
C      lunwrit= 0
      lunwrit= 20
      if( lunwrit.gt.0 ) then
C  (ASCII file)
         ifmt= 0
         lhafile= 'lhaext_z1j_matched_asc.dat'
         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
C  (binary file)
C         ifmt= 1
C         lhafile= 'lhaext_bin.dat'
C         open(lunwrit,file=lhafile,form='UNFORMATTED',status='NEW')
      endif

C...Book histograms.
Ch      call hlimit(lhcom)

Ch      call hbook1(1,'mass of Z$',100,0.,200.,0.)
Ch      call hbook1(2,'pt of Z$',100,0.,200.,0.)
Ch      call hbook1(3,'rapidity of Z$',100,-5.,5.,0.)

Ch      call hbook1(11,'mass of Z (pos)$',100,0.,200.,0.)
Ch      call hbook1(12,'pt of Z (pos)$',100,0.,200.,0.)
Ch      call hbook1(13,'rapidity of Z (pos)$',100,-5.,5.,0.)

Ch      call hbook1(21,'mass of Z (neg)$',100,0.,200.,0.)
Ch      call hbook1(22,'pt of Z (neg)$',100,0.,200.,0.)
Ch      call hbook1(23,'rapidity of Z (neg)$',100,-5.,5.,0.)

C...Initialization.
      CALL UPINIT
      call RUPdump

C  Output the header data.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.0 ) then
            call lhaWritHdAsc(lunwrit)
         elseif( ifmt.eq.1 ) then
            call lhaWritHdBin(lunwrit)
         endif
      endif

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      xabs= SUMXSEC
      evpos= 0.d0
      evneg= 0.d0

      DO IEV = 1,nevent

C...Event generation.

C  Process selection.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

C  Generation
         CALL UPEVNT

C         IF (IEV.LE.2 .OR. MOD(IEV,10).EQ.0) THEN
         IF (IEV.LE.2 .OR. MOD(IEV,10000).EQ.0) THEN
            WRITE(*,*) ' '
            WRITE(*,*) 'Event# ',IEV
            call EUPdump
         ENDIF

C  Output the event data.
         if( lunwrit.gt.0 ) then
            if( ifmt.eq.0 ) then
               call lhaWritEvAsc(lunwrit)
            elseif( ifmt.eq.1 ) then
               call lhaWritEvBin(lunwrit)
            endif
         endif

C  Analysis
         do i=1,NUP
            if( iabs( IDUP(i) ).eq.23 ) i_Z= i
         enddo

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

         amZ= PUP(5,i_Z)
         ptZ= sqrt( PUP(1,i_Z)**2 +PUP(2,i_Z)**2 )
         rapZ= log( ( PUP(4,i_Z) +PUP(3,i_Z) )
     >             /( PUP(4,i_Z) -PUP(3,i_Z) ) )/2.d0
Ch         call hf1(1,real(amZ),weight)
Ch         call hf1(2,real(ptZ),weight)
Ch         call hf1(3,real(rapZ),weight)
Ch         if( weight.ge.0. ) then
Ch            call hf1(11,real(amZ),1.)
Ch            call hf1(12,real(ptZ),1.)
Ch            call hf1(13,real(rapZ),1.)
Ch         else
Ch            call hf1(21,real(amZ),1.)
Ch            call hf1(22,real(ptZ),1.)
Ch            call hf1(23,real(rapZ),1.)
Ch         endif

      ENDDO

      WRITE(*,'(/8X,''########## Event generation completed ##########''
     >     )')
      print *,'Total number of failure returns from PSKINI',
     >     nfail_pskini

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6)', rneg
      xsec= xabs*evdif/evtot
      xerr= xabs/sqrt( evtot )
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'-----------------------------'
      print *,''

C...Histograms.
Ch      call histdo
C
C -- Store histograms.
C
Ch      if( flhist(1:1).NE.'*' ) then
Ch        call hrput(0,flhist,'N')
Ch      endif

      stop
      END
