C    _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C   _/_/  Subprocess function   _/_/
C  _/_/  Date   06/04/2002     _/_/
C _/_/  Author Soushi Tsuno   _/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
      function fnc422(x)
      implicit real*8(a-h,o-z)
      real*8   fnc422

#include "define.h"

      include 'incl4221.h'
      include 'inclk.h'
      include 'grchad.inc'

      parameter ( mxdim = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL

      real*8 ansm, ans
      real*8 x(mxdim),ytmp,ajacob
      external drn

C+------------------------------------------------+
#ifdef VBASESMPI
      include 'inclvs.f'
      real*8  xv(nsize, mxdim),ansv(nsize)
      common /vbhdat/ xv,ansv
      common /vbhcnt/ isamp
#endif
C+------------------------------------------------+

      if (igsub.gt.300.and.ibsint.lt.2) then
C...Set Parameter for kinematics
         call grcikin
C...Integration/Event Generation : 1/0
         do i = 1, ndim
            xrun(i) = x(i)
         enddo
      else
         igsub = 422
      endif

C...Set particle combination
      call grcspid
C...Set Particle Masses
      call setmas
C...Set Process
      call g422finit
C...Set Kinematic Variables
      call grcsval

      if (irej.gt.0) then
         if (ibsint.eq.1) inkv = inkv + 1
         go to 999
      endif

C...Set Flavor from Proton/Anti-Proton
      call grcprtnqg
C...Fill Kinematics
      ajacob = 0.0d0
      call grcskin(pgrc,ajacob)
      yacob = yacob*ajacob
C...Set Coupling constant
      call grcsene
C...Set Vertex
      call a422mclr
      call amparm

      ansum = 0.0d0
      dft   = 0.0d0
      ytmp = yacob

C...Loop over Each Phase Space if necessary
      do 1000 ireg = 1 , mxreg
         yacob = ytmp

C...Set User Defined Function
         call grcusrfnc422(ireg)
C...Apply Kinematical Cuts
         call grcscut
         if (irej.gt.0) go to 1000

C  Force the initial partons and the radiation be massless, 
C  since the LL approximation is valid for massless ones only.
         if( matching.eq.1 ) then
            call mzero422
         endif

         do 20 i = 1, 4
            pe4221(i) = pgrc(i, kperm(1))
            pe4222(i) = pgrc(i, kperm(2))
            pe4223(i) = pgrc(i, kperm(3))
            pe4224(i) = pgrc(i, kperm(4))
            pe4225(i) = pgrc(i, kperm(5))
 20      continue

C...Set Invariants
         do i=1,5
            do j=1,5
               prod(i,j) = pgrc(4,i)*pgrc(4,j) 
     $              - pgrc(1,i)*pgrc(1,j) 
     $              - pgrc(2,i)*pgrc(2,j) 
     $              - pgrc(3,i)*pgrc(3,j)
            enddo
         enddo

C...Calculate Matrix Elements
         call a422kptbl
         call a422mptbl
         call a422mpsum(ansm)
         ansm= ansm*aspin

C  LLL subtraction.
         if( matching.eq.1 ) then
            call lll422(anslll)
            ansm= ansm -anslll
            call mrest422
         endif

C         fknorm = yacob*aspin
C         ans    = ansm*fknorm/aident
         ans    = ansm*yacob/aident

C  Return the absolute value to BASES/SPRING.
C  The signed result is separately stored.
         signedres= ans
         ans= abs( ans )

         ansum  = ansum + ans

C...Store Color String Information
         if (ibsint.eq.2) then
            grcdsig(ireg) = ans
            call sp422detc(ireg)
            call sp422deth(ireg)
         endif
 1000 continue

C...Set Value of Function
      fnc422 = ansum

C...Check Integration
      if (ibsint.eq.1) then
         inbs = inbs + 1
         if (mod(inbs,nfprt).eq.0) then
            write(*,*) inbs
         endif

         if (irej.eq.2) inkc = inkc + 1
         if (irej.eq.3) in4m = in4m + 1
         if (irej.eq.4) inac = inac + 1

         funcmax = max(funcmax,fnc422)

C+------------------------------------------------+
#ifndef VBASESMPI
         do i = 1, ndim
            call xhfill(i,x(i),fnc422)
         enddo
#endif
C+------------------------------------------------+

C+------------------------------------------------+
#ifdef VBASESMPI
         do i = 1, ndim
            xv(isamp,i) = x(i)
         enddo
         ansv(isamp) = fnc422
#endif
C+------------------------------------------------+

         if (funcmax.le.fnc422) then
         endif
      endif

      return
 999  continue
      yacob = 0.0d0
      fnc422 = 0.0d0
      return
      end
