      subroutine me500( kfgen, p, ans )
C  Calculate the matrix element of the process 500: q qbar -> fbar f
C  mediated by s-channel Z/gamma*; f = a lepton or a quark.
C  The flavor information has to be given by "kfgen", since it is reset to
C  u ubar -> e+ e- in "g500finit".
C  The particle ordering in "kfgen" is not important; "kfcode" is referred 
C  only to find the flavor of the initial state and the final state in the 
C  ME calculation.
      implicit real*8(a-h,o-z)
      include 'incl5001.h'
      include 'inclk.h'

      integer kfgen(4)
      real*8 p(4,4)

      call g500finit
      call a500mclr
C      call amparm

      do i=1,4
         kfcode(i)= kfgen(i)
      enddo

      do i=1,4
         pe5001(i) = p(i,1)
         pe5002(i) = p(i,2)
         pe5003(i) = p(i,3)
         pe5004(i) = p(i,4)
      enddo

      do i=1,4
         do j=1,4
            prod(i,j) = p(4,i)*p(4,j) -p(1,i)*p(1,j) 
     >           - p(2,i)*p(2,j) -p(3,i)*p(3,j)
         enddo
      enddo

      do i=1,4
         amass2(i)= p(4,i)**2 -p(3,i)**2 -p(2,i)**2 -p(1,i)**2
         if( amass2(i).lt.0.d0 ) amass2(i)= 0.d0
         amass1(i)= sqrt( amass2(i) )
      enddo

      call a500kptbl
      call a500mptbl
      call a500mpsum( ansm )
      ans= ansm*aspin

      return
      end
